package net.knarcraft.hungerarena.Listeners;

import net.knarcraft.hungerarena.HungerArena;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.World;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.scoreboard.DisplaySlot;

import java.util.UUID;

public class DeathListener implements Listener {
    public final HungerArena plugin;

    public DeathListener(HungerArena m) {
        this.plugin = m;
    }

    int a = 0;

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onPlayerRespawn(PlayerRespawnEvent event) {
        final Player p = event.getPlayer();
        String pname = p.getName();

        //get the arena the player has died in...	(may be not the one he joined...)
        String ThisWorld = p.getWorld().getName();
        for (int z : plugin.worldNames.keySet()) {
            if (plugin.worldNames.get(z) != null) {
                if (plugin.worldNames.get(z).equals(ThisWorld)) {
                    a = z;
                }
            }
        }

        //Jeppa: Fix for lonely players :)
        for (int i : plugin.Dead.keySet()) {
            if ((plugin.Dead.get(i) != null) && (plugin.Dead.get(i).contains(pname)) && (plugin.MatchRunning.get(i) == null)) {
                plugin.Dead.get(i).clear();
            }
        }

        for (int i = 0; i < plugin.needInv.size(); i++) {
            if (plugin.needInv.contains(pname)) {
                RespawnDeadPlayer(p, a);
            }
        }
    }

    private void RespawnDeadPlayer(Player p, int a) {
        final Player player = p;
        String[] Spawncoords = plugin.spawns.getString("Spawn_coordinates." + a).split(",");
        World spawnw = plugin.getServer().getWorld(Spawncoords[3]);
        double spawnx = Double.parseDouble(Spawncoords[0]);
        double spawny = Double.parseDouble(Spawncoords[1]);
        double spawnz = Double.parseDouble(Spawncoords[2]);
        final Location Spawn = new Location(spawnw, spawnx, spawny, spawnz);
        Bukkit.getServer().getScheduler().scheduleSyncDelayedTask(plugin, () -> {
            player.teleport(Spawn);
            plugin.restoreInventory(player, player.getName());
        }, 10L);
    }

    @EventHandler(priority = EventPriority.HIGHEST)
    public void onPlayerDeath(PlayerDeathEvent event) {
        Player p = event.getEntity();
        Server s = p.getServer();
        String pname = p.getName();
        UUID playerId = p.getUniqueId();
        if (plugin.getArena(p) != null) {
            a = plugin.getArena(p).getArenaId();
            String leftmsg = null;
            clearInv(p);
            event.getDrops().clear();
            p.getScoreboard().clearSlot(DisplaySlot.SIDEBAR);
            plugin.scoreboards.remove(p.getName());
            int players = plugin.Playing.get(a).size() - 1;
            if (plugin.arenaPlayers.get(playerId).isFrozen()) {
                doFrozenPlayerStuff(p, players, leftmsg, pname, playerId, event, s);
            } else {
                doNonFrozenPlayerStuff(p, players, leftmsg, pname, playerId, event, s);
            }
        }
    }

    private void doFrozenPlayerStuff(Player p, int players, String leftmsg, String pname, UUID playerId, PlayerDeathEvent event, Server s) {
        //Basically, if a frozen player is killed by something which isn't another player, assume the reason the player
        // was killed was because they left their pedestal too early
        if (!(p.getKiller() instanceof Player)) {
            leftmsg = ChatColor.BLUE + "There are now " + players + " tributes left!";
            fireCannon(p);
            event.setDeathMessage("");
            if (plugin.config.getBoolean("broadcastAll")) {
                p.getServer().broadcastMessage(pname + ChatColor.LIGHT_PURPLE + " Stepped off their pedestal too early!");
            } else {
                for (UUID gn : plugin.Playing.get(a)) {
                    Player g = plugin.getServer().getPlayer(gn);
                    g.sendMessage(pname + ChatColor.LIGHT_PURPLE + " Stepped off their pedestal too early!");
                }
            }
            plugin.arenaPlayers.get(playerId).setFrozen(false);
            plugin.arenaPlayers.get(playerId).setInArena(false);
            plugin.arenaPlayers.get(playerId).setArena(null);
            if (plugin.config.getBoolean("broadcastAll")) {
                p.getServer().broadcastMessage(leftmsg);
            } else {
                for (UUID gn : plugin.Playing.get(a)) {
                    Player g = plugin.getServer().getPlayer(gn);
                    g.sendMessage(leftmsg);
                }
            }
            plugin.winner(a);
        }
    }

    private void doNonFrozenPlayerStuff(Player player, int players, String leftmsg, String pname, UUID playerId, PlayerDeathEvent event, Server s) {
        leftmsg = ChatColor.BLUE + "There are now " + players + " tributes left!";
        fireCannon(player);
        plugin.Dead.get(a).add(playerId);
        plugin.Playing.get(a).remove(playerId);
        if (player.getKiller() instanceof Player) {
            if (player.getKiller().getInventory().getItemInMainHand().getType() == Material.AIR) {
                Player killer = player.getKiller();
                String killername = killer.getName();
                event.setDeathMessage("");
                if (plugin.config.getBoolean("broadcastAll")) {
                    s.broadcastMessage(ChatColor.LIGHT_PURPLE + "**BOOM** Tribute " + pname + " was killed by tribute " + killername + " with their FIST!");
                    s.broadcastMessage(leftmsg);
                } else {
                    for (UUID gn : plugin.Playing.get(a)) {
                        Player g = plugin.getServer().getPlayer(gn);
                        g.sendMessage(ChatColor.LIGHT_PURPLE + "**BOOM** Tribute " + pname + " was killed by tribute " + killername + " with their FIST!");
                        g.sendMessage(leftmsg);
                    }
                }
                if (plugin.Kills.containsKey(killername)) {
                    plugin.Kills.put(killername, plugin.Kills.get(killername) + 1);
                } else {
                    plugin.Kills.put(killername, 1);
                }
                if (plugin.Kills.containsKey("__SuM__")) {
                    plugin.Kills.put("__SuM__", plugin.Kills.get("__SuM__") + 1);
                } else {
                    plugin.Kills.put("__SuM__", 1);
                }
                plugin.winner(a);
            } else {
                Player killer = player.getKiller();
                String killername = killer.getName();
                String weapon = "a(n) " + killer.getInventory().getItemInMainHand().getType().name().replace('_', ' ');
                if (killer.getInventory().getItemInMainHand().hasItemMeta()) {
                    if (killer.getInventory().getItemInMainHand().getItemMeta().hasDisplayName()) {
                        weapon = killer.getInventory().getItemInMainHand().getItemMeta().getDisplayName();
                    }
                }
                String msg = ChatColor.LIGHT_PURPLE + "**BOOM** Tribute " + pname + " was killed by tribute " + killername + " with " + weapon;
                event.setDeathMessage("");
                if (plugin.config.getBoolean("broadcastAll")) {
                    s.broadcastMessage(msg);
                    s.broadcastMessage(leftmsg);
                } else {
                    for (UUID gn : plugin.Playing.get(a)) {
                        Player g = plugin.getServer().getPlayer(gn);
                        g.sendMessage(msg);
                        g.sendMessage(leftmsg);
                    }
                }
                if (plugin.Kills.containsKey(killername)) {
                    plugin.Kills.put(killername, plugin.Kills.get(killername) + 1);
                } else {
                    plugin.Kills.put(killername, 1);
                }
                if (plugin.Kills.containsKey("__SuM__")) {
                    plugin.Kills.put("__SuM__", plugin.Kills.get("__SuM__") + 1);
                } else {
                    plugin.Kills.put("__SuM__", 1);
                }
                plugin.winner(a);
            }
        } else {
            event.setDeathMessage("");
            if (plugin.config.getBoolean("broadcastAll")) {
                s.broadcastMessage(ChatColor.LIGHT_PURPLE + pname + " died of natural causes!");
                s.broadcastMessage(leftmsg);
            } else {
                for (UUID gn : plugin.Playing.get(a)) {
                    Player g = plugin.getServer().getPlayer(gn);
                    g.sendMessage(ChatColor.LIGHT_PURPLE + pname + " died of " + ChatColor.ITALIC + " probably " + ChatColor.LIGHT_PURPLE + "natural causes!");
                    g.sendMessage(leftmsg);
                }
            }
            plugin.winner(a);
        }
    }

    private void fireCannon(Player player) {
        if (plugin.config.getBoolean("Cannon_Death")) {
            double y = player.getLocation().getY();
            double newY = y + 200;
            double x = player.getLocation().getX();
            double z = player.getLocation().getZ();
            Location strike = new Location(player.getWorld(), x, newY, z);
            player.getWorld().strikeLightning(strike);
        }
    }

    private void clearInv(Player p) {
        p.getInventory().clear();
        p.getInventory().setBoots(null);
        p.getInventory().setChestplate(null);
        p.getInventory().setHelmet(null);
        p.getInventory().setLeggings(null);
        p.updateInventory();
    }
}
