package net.knarcraft.hungerarena.Listeners;

import net.knarcraft.hungerarena.HungerArena;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerChangedWorldEvent;

public class WorldChange implements Listener {
    public final HungerArena plugin;

    public WorldChange(HungerArena m) {
        plugin = m;
    }

    @EventHandler(priority = EventPriority.LOWEST)
    public void worldChangeLow(PlayerChangedWorldEvent event) {
        Player p = event.getPlayer();
        String pname = p.getName();
        String ThisWorld = p.getWorld().getName();
        String FromWorld = event.getFrom().getName();
        if (!plugin.worldNames.containsValue(ThisWorld) && plugin.worldNames.containsValue(FromWorld)) {
            plugin.restoreInventory(p, pname);
        }
    }

    @EventHandler(priority = EventPriority.HIGH)
    public void worldChangeHigh(PlayerChangedWorldEvent event) {
        Player p = event.getPlayer();
        String pname = p.getName();
        String ThisWorld = p.getWorld().getName();
        int a = 0;
        for (int i : plugin.worldNames.keySet()) {
            if (plugin.worldNames.get(i) == null) {
                continue;
            }
            if (plugin.worldNames.get(i).equals(ThisWorld)) {
                a = i;
                if (plugin.arenaPlayers.get(p.getUniqueId()).isFrozen()) {
                    return;
                } else {
                    plugin.restoreInventory(p, pname);
                    if (plugin.config.getBoolean("joinTeleport")) {
                        String[] spawnCoordinates = plugin.spawns.getString("Spawn_coordinates." + a).split(",");
                        double spawnX = Double.parseDouble(spawnCoordinates[0]);
                        double spawnY = Double.parseDouble(spawnCoordinates[1]);
                        double spawnZ = Double.parseDouble(spawnCoordinates[2]);
                        Location Spawn = new Location(p.getWorld(), spawnX, spawnY, spawnZ);
                        if (!p.getLocation().getBlock().equals(Spawn.getBlock())) {
                            p.teleport(Spawn);
                        }
                    }
                }
            }
        }
    }
}
